#include <iostream>
#include <list>
#include <queue>
#include <map>
#include <string>

using namespace std;

typedef struct Loom
{
    string Nimi;
    map<string, Loom*> Sisse;
    map<string, Loom*> Valja;
} Loom;

map<string, Loom> graaf;

Loom* leia_loom(string nimi)
{
    if (!graaf.count(nimi)) { // kui selle nimega looma veel ei ole
        Loom n; 
        n.Nimi = nimi;
        graaf[nimi] = n; // lisame selle
    }
    return &graaf[nimi];
}

int main()
{
    int servi;
    cin >> servi;
    for (int i = 0; i < servi; i++) {
        string yks, kaks;
        cin >> yks >> kaks;
        Loom* esimene = leia_loom(yks);
        Loom* teine = leia_loom(kaks);
        esimene->Valja[teine->Nimi] = teine;
        teine->Sisse[esimene->Nimi] = esimene;
    }

    list<string> valjund;
    queue<Loom*> jrkd;

    // kigepealt leiame kik tipud, millel sissetulevaid kaari ei ole. Need loomad
    // saavad olla kige tugevamad teadaoleva info phjal.
    for (map<string, Loom>::iterator it = graaf.begin(); it != graaf.end(); ++it) {
        if (it->second.Sisse.empty())  
            jrkd.push(&it->second);
    }

    while (!jrkd.empty()) { // kuni on veel ttlemata tippe
        Loom* n = jrkd.front();
        jrkd.pop();
        valjund.push_back(n->Nimi); // lisame vastusesse
        
        for (map<string, Loom*>::iterator it2 = n->Valja.begin(); it2 != n->Valja.end(); ++it2) {
            Loom* jrgm = it2->second;
            // eemaldame naabrilt kik vaadeldavast tipust sissetulevad kaared
            jrgm->Sisse.erase(n->Nimi); 
            if (jrgm->Sisse.empty()) // kui naabril rohkem sissetulevaid kaari pole
                jrkd.push(jrgm); // lisame selle jrjekorda
        }
        n->Valja.clear(); // eemaldame tipu kik vljuvad kaared
    }

    for (map<string, Loom>::iterator it = graaf.begin(); it != graaf.end(); ++it) {
        if (it->second.Sisse.empty()) continue;
        cout << "EI SAA" << endl;
        return 0;
    }

    for (list<string>::iterator it = valjund.begin(); it != valjund.end(); ++it) {
        cout << *it << " ";
    }
    cout << endl;
    return 0;
}

